<?php
//OK, First thing, are all of the required variables set?
if (isset($argv[1],$argv[2],$argv[3])) {
//All variables are set and ready to roll, continue

//variables from the command line
$address = $argv[1];
$timeout = $argv[2];
$notify = $argv[3];
$attempts = "1";


//normal variables
$datestamp = date("m/d/y : H:i:s", time());
$downfile = "$address";
$folder = "/usr/local/online-ping";
$fromaddress = "rbessey@co.walla-walla.wa.us";


//here is the test
$str = exec("ping -c 1 -w $timeout $address", $input, $result);

//if statement for results
if ($result == 0){

//ping is online
echo"online\n";
	//checking to see if a file exists (Host was down)
	if (file_exists("$folder/$downfile")) {
		//the host was down, need to see if it was above the attempts
		echo "The file $downfile exists\n";
		//Open the file and get the attempts
		$fp = fopen("$folder/$downfile", "r");
		$counter = fread($fp, 1024);
		fclose($fp);
		//lets check our attempts
		if ($counter >= $attempts ) {
			//we hit the limit, send email
			echo "limit was approached, send e-mail\n";
			//now to send the e-mail
			mail( "$notify", "$downfile is up", "$downfile is up $datestamp", "From: $fromaddress" );
		} else {
			//limit not exeeded, do nothing
			echo "limit not exceeded, do nothing\n";
		}
		//delete the down file
		unlink("$folder/$downfile");
		//log that its back up
		$fh = fopen("$folder/log.txt", 'a') or die("can't open file");
		fwrite($fh, "$downfile is up $datestamp\n");
		fclose($fh);

	} else {
		//the host was not down, continue on and do nothing
		echo "The file $downfile does not exist\n";
	} 

}else{

//Ping is down
echo "NO";

//offline
echo"offline\n";
	//checking to see if a file exists (Host was up)
	if (file_exists("$folder/$downfile")) {
		//the host was down, continue, do nothing
		echo "The file $downfile exists\n";
		//lets increase the counter by 1
		//Get the counter value and add 1
		$fp = fopen("$folder/$downfile", "r");
		$counter = fread($fp, 1024);
		fclose($fp);
		$counter = $counter + 1;
		$fp = fopen("$folder/$downfile", "w");
		fwrite($fp, $counter);
		fclose($fp);
	} else {
		//the host was not down
		//create the down file
		echo "The file $downfile does not exist\n";
		//Set the counter to 1 since this is the 1st notification
		$counter = '1';
		$fh = fopen("$folder/$downfile", 'w') or die("can't open file");
		fwrite($fh, $counter);
		fclose($fh);
	} 
        //Right here we need to check the counters, if above limit send e-mail
        if ($counter == $attempts ) {
                //we hit the limit, send email
                echo "limit hit,send e-mail\n";
                mail( "$notify", "$downfile down", "$downfile is down after $counter tries $datestamp", "From: $fromaddress" );

        } else {
                //limit not exeeded, do nothing
                echo "limit not exceeded, do nothing\n";
        }
        //Finally, lets log the outage in our log file
        $fh1 = fopen("$folder/log.txt", 'a') or die("can't open file");
        fwrite($fh1, "$downfile is down with $counter tries $datestamp\n");
        fclose($fh1);


}

} else {
    echo "
ERROR!

Usage php online-ping.php Ipaddy Timeout NotifyAddress
Example: php online-ping.php 10.10.10.1 1 user@domain.com\n";
}


?>
